'use strict';

var React = require('react');
var classnames = require('classnames');
var utilsCommons = require('@highlight-ui/utils-commons');
var Typography = require('@highlight-ui/typography');
var Button = require('@highlight-ui/button');
var Icon = require('@highlight-ui/icon');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () {
                        return e[k];
                    }
                });
            }
        });
    }
    n['default'] = e;
    return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var Typography__default = /*#__PURE__*/_interopDefaultLegacy(Typography);
var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);
var Icon__default = /*#__PURE__*/_interopDefaultLegacy(Icon);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var styles = {"emptyStateContainer":"EmptyState-module__1_2p1qTM__v1-0-5","emptyStateIconContainer":"EmptyState-module__1W60mT0F__v1-0-5","emptyStateTitle":"EmptyState-module__2c2KO4PH__v1-0-5","emptyStateDescription":"EmptyState-module__c-GN5pKi__v1-0-5","emptyStateCustomImage":"EmptyState-module__1qHLXj52__v1-0-5"};

function EmptyStateWithRef(_a, ref) {
    var className = _a.className, _b = _a.description, description = _b === void 0 ? 'And this is additional text under the empty state' : _b, iconColor = _a.iconColor, _c = _a.iconFamily, iconFamily = _c === void 0 ? 'solid' : _c, _d = _a.iconName, iconName = _d === void 0 ? 'exclamation-square' : _d, _e = _a.iconSize, iconSize = _e === void 0 ? 26 : _e, metadata = _a.metadata, onRetryButtonClick = _a.onRetryButtonClick, _f = _a.retryButtonText, retryButtonText = _f === void 0 ? 'Retry' : _f, _g = _a.retryButtonTheme, retryButtonTheme = _g === void 0 ? 'primary' : _g, _h = _a.showRetryButton, showRetryButton = _h === void 0 ? false : _h, _j = _a.title, title = _j === void 0 ? 'This is an empty state' : _j, _k = _a.customImage, customImage = _k === void 0 ? '' : _k, _l = _a.customImageClassName, customImageClassName = _l === void 0 ? '' : _l;
    var containerClassName = classnames__default['default'](styles.emptyStateContainer, className);
    var retryBtnMetadata = __assign(__assign({}, ((metadata === null || metadata === void 0 ? void 0 : metadata.testId) ? { testId: metadata.testId + "-retry-btn" } : {})), ((metadata === null || metadata === void 0 ? void 0 : metadata.actionName)
        ? { actionName: metadata.actionName + "-retry-btn" }
        : {}));
    return (React__namespace.createElement("div", __assign({}, utilsCommons.parseMetadata(metadata), { className: containerClassName, ref: ref }),
        React__namespace.createElement("div", { className: styles.emptyStateIconContainer }, customImage ? (React__namespace.createElement("img", { src: customImage, className: classnames__default['default'](styles.emptyStateCustomImage, customImageClassName), alt: "empty state" })) : (React__namespace.createElement(Icon__default['default'], { name: iconName, color: iconColor, size: iconSize, type: iconFamily }))),
        React__namespace.createElement(Typography__default['default'], { variant: "heading-2", component: "div", className: styles.emptyStateTitle }, title),
        React__namespace.createElement(Typography__default['default'], { variant: "body-1", component: "div", className: styles.emptyStateDescription }, description),
        showRetryButton && (React__namespace.createElement("div", { className: styles.retryButtonContainer },
            React__namespace.createElement(Button__default['default'], { theme: retryButtonTheme, onClick: onRetryButtonClick, metadata: retryBtnMetadata }, retryButtonText)))));
}
EmptyStateWithRef.displayName = 'EmptyState';
var EmptyState = React__namespace.forwardRef(EmptyStateWithRef);
var EmptyState$1 = React__namespace.memo(EmptyState);

module.exports = EmptyState$1;
//# sourceMappingURL=index.js.map
